
Object subclass: #CustomerOrder
    instanceVariableNames: 'orderPositions '
    classVariableNames: ''
    poolDictionaries: ''!

CustomerOrder comment: 'Diese Klasse entspricht der Klasse Kundenauftrag aus der OBA-Analyse.

Instanzvariable:
	orderPositions <OrderedCollection>
		Menge der ''Bestellposten'' eines Kundenauftrages.
'!

!CustomerOrder class publicMethods !

new
	"Instanzvariablen werden initialisiert."
	^super new initialize! !

CustomerOrder class categoriesFor: #new are:((OrderedCollection new)
	add: 'Create';
	yourself)!

!CustomerOrder publicMethods !

addPosition: anOrderPosition
	"Erweiterung des Kundenauftrages."
	orderPositions add: anOrderPosition!

initialize
	"Anfangswerte werden gesetzt."
	orderPositions := OrderedCollection new!

orderPositions
	"Entspricht der Dienstleistung 'Bestellposten'.
	Ausgabe des Kundenauftrags."
	^orderPositions!

release
	"Objektdaten werden geloescht."
	orderPositions do: [:position | position release].
	orderPositions := nil!

removePosition: anOrderPosition
	"Erweiterung des Kundenauftrages."
	orderPositions remove: anOrderPosition ifAbsent:[]
	! !

CustomerOrder categoriesFor: #release are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
CustomerOrder categoriesFor: #orderPositions are:((OrderedCollection new)
	add: 'Services';
	yourself)!
CustomerOrder categoriesFor: #removePosition: are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!
CustomerOrder categoriesFor: #initialize are:((OrderedCollection new)
	add: 'Initialize';
	yourself)!
CustomerOrder categoriesFor: #addPosition: are:((OrderedCollection new)
	add: 'Accessing';
	yourself)!