
StorageArea subclass: #WarehouseBuffer
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WarehouseBuffer comment: 'Diese Klasse entspricht der Klasse Bereitstellungsflaeche
aus der OBA-Analyse.'!

!WarehouseBuffer publicMethods !

clearFrom: aTransportationUnitOrSupplyPalette
	"Entspricht der Dienstleistung 'Raeumen'."
	| place |
	place := self placeOf:  aTransportationUnitOrSupplyPalette.
	place isNil ifTrue: [^self error: 'Cannot find.'].
	places removeKey: place
!

drop:  aTransportationUnitOrSupplyPalette at: aPoint
	"Entspricht der Dienstleistung 'Abstellen'."
	(places at: aPoint ifAbsent: []) isNil
		ifFalse: [^self error: 'Place already used.'].
	places at: aPoint put: aTransportationUnitOrSupplyPalette
!

hasSufficientSpaceFor: aCollection
	"Entspricht der Dienstleistung 'Frei'."
	^aCollection size <= (self totalSpace - self usedSpace)!

ship: aTransportationUnit
	"Entspricht der Dienstleistung 'Versenden'."
	"Hier kann der Code noch entsprechend der
	Besonderheiten des Frachtsystemsergaenzt werden."
	Transcript show: 'Order for customer is ready.'; cr! !

WarehouseBuffer categoriesFor: #clearFrom: are:((OrderedCollection new)
	add: 'Services';
	yourself)!
WarehouseBuffer categoriesFor: #ship: are:((OrderedCollection new)
	add: 'Services';
	yourself)!
WarehouseBuffer categoriesFor: #hasSufficientSpaceFor: are:((OrderedCollection new)
	add: 'Services';
	yourself)!
WarehouseBuffer categoriesFor: #drop:at: are:((OrderedCollection new)
	add: 'Services';
	yourself)!